#include "Timer.h"

volatile uint64_t timer2_ms_counter=0;



tTimer::tTimer(void){}

ISR(TIMER2_COMPA_vect){
   timer2_ms_counter++;
}

void tTimer::init_timer(){
	//CTC mode with a prescaler 64    f = 16x10^6 Hz --> T= 1/f = 1/(16x10^6) = 6.25x10^-8 s--> Tp64 = 6.25x10^-8 / 64 = 9.765x10^-10 s 
	Serial.println("Initializing Timer 2....");
	TCCR2A = 0x0;
	TCCR2A |= (1<<(WGM21)) | (1<<(COM2A1)) | (1<<(COM2B1));
	TCCR2A &=  ~(1<<(WGM20));
	Serial.print(" TCCR2A="); Serial.println(TCCR2A,BIN);
	TCCR2B &= ~(1<<(WGM22)) & ~(1<<(CS21)) & ~(1<<(CS20));
	TCCR2B |= (1<<(CS22));
	Serial.print(" TCCR2B="); Serial.println(TCCR2B,BIN);
	TIMSK2 |= (1<<OCIE2A);
	OCR2A  = 249;
	interrupts();
	
}

void tTimer::start_timer(){
	TIMSK2 &= ~(1<<OCIE2A);
		timer_ms_count=timer2_ms_counter;
	TIMSK2 |= (1<<OCIE2A);
}


uint64_t tTimer::get_time_ms(){
	uint64_t aux_time=0;
	TIMSK2 &= ~(1<<OCIE2A);
		aux_time=timer2_ms_counter;
	TIMSK2 |= (1<<OCIE2A);
	return aux_time;
}